// Code generated by protoc-gen-go. DO NOT EDIT.
// source: node.proto

package node

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	common "github.com/spiffe/spire/proto/spire/common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

//* Trust domain bundle
type Bundle struct {
	// bundle identifier, i.e. the SPIFFE ID for the trust domain
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// bundle data (ASN.1 encoded X.509 certificates)
	CaCerts              []byte   `protobuf:"bytes,2,opt,name=ca_certs,json=caCerts,proto3" json:"ca_certs,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Bundle) Reset()         { *m = Bundle{} }
func (m *Bundle) String() string { return proto.CompactTextString(m) }
func (*Bundle) ProtoMessage()    {}
func (*Bundle) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{0}
}

func (m *Bundle) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Bundle.Unmarshal(m, b)
}
func (m *Bundle) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Bundle.Marshal(b, m, deterministic)
}
func (m *Bundle) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Bundle.Merge(m, src)
}
func (m *Bundle) XXX_Size() int {
	return xxx_messageInfo_Bundle.Size(m)
}
func (m *Bundle) XXX_DiscardUnknown() {
	xxx_messageInfo_Bundle.DiscardUnknown(m)
}

var xxx_messageInfo_Bundle proto.InternalMessageInfo

func (m *Bundle) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Bundle) GetCaCerts() []byte {
	if m != nil {
		return m.CaCerts
	}
	return nil
}

// A type which contains the "Spiffe Verifiable Identity Document" and
// a TTL indicating when the SVID expires.
type X509SVID struct {
	// X509 SVID and intermediates necessary to form a chain of trust back
	// to a root CA in the bundle.
	CertChain []byte `protobuf:"bytes,3,opt,name=cert_chain,json=certChain,proto3" json:"cert_chain,omitempty"`
	// SVID expiration timestamp (in seconds since Unix epoch)
	ExpiresAt            int64    `protobuf:"varint,2,opt,name=expires_at,json=expiresAt,proto3" json:"expires_at,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *X509SVID) Reset()         { *m = X509SVID{} }
func (m *X509SVID) String() string { return proto.CompactTextString(m) }
func (*X509SVID) ProtoMessage()    {}
func (*X509SVID) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{1}
}

func (m *X509SVID) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_X509SVID.Unmarshal(m, b)
}
func (m *X509SVID) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_X509SVID.Marshal(b, m, deterministic)
}
func (m *X509SVID) XXX_Merge(src proto.Message) {
	xxx_messageInfo_X509SVID.Merge(m, src)
}
func (m *X509SVID) XXX_Size() int {
	return xxx_messageInfo_X509SVID.Size(m)
}
func (m *X509SVID) XXX_DiscardUnknown() {
	xxx_messageInfo_X509SVID.DiscardUnknown(m)
}

var xxx_messageInfo_X509SVID proto.InternalMessageInfo

func (m *X509SVID) GetCertChain() []byte {
	if m != nil {
		return m.CertChain
	}
	return nil
}

func (m *X509SVID) GetExpiresAt() int64 {
	if m != nil {
		return m.ExpiresAt
	}
	return 0
}

// A message returned by the Spire Server, which includes a map of signed SVIDs and
//a list of all current Registration Entries which are relevant to the caller SPIFFE ID.
type X509SVIDUpdate struct {
	// A map containing SVID values keyed by:
	//  - SPIFFE ID in message 'AttestResponse'        (Map[SPIFFE_ID] => SVID)
	//  - Entry  ID in message 'FetchX509SVIDResponse' (Map[Entry_ID]  => SVID)
	Svids map[string]*X509SVID `protobuf:"bytes,1,rep,name=svids,proto3" json:"svids,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// A type representing a curated record that the Spire Server uses to set up
	// and manage the various registered nodes and workloads that are controlled by it.
	RegistrationEntries []*common.RegistrationEntry `protobuf:"bytes,3,rep,name=registration_entries,json=registrationEntries,proto3" json:"registration_entries,omitempty"`
	// Trust bundles associated with the SVIDs, keyed by trust domain SPIFFE
	// ID. Bundles included are the trust bundle for the server trust domain
	// and any federated trust domain bundles applicable to the SVIDs.
	// Supersedes the deprecated `bundle` field.
	Bundles              map[string]*common.Bundle `protobuf:"bytes,5,rep,name=bundles,proto3" json:"bundles,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}                  `json:"-"`
	XXX_unrecognized     []byte                    `json:"-"`
	XXX_sizecache        int32                     `json:"-"`
}

func (m *X509SVIDUpdate) Reset()         { *m = X509SVIDUpdate{} }
func (m *X509SVIDUpdate) String() string { return proto.CompactTextString(m) }
func (*X509SVIDUpdate) ProtoMessage()    {}
func (*X509SVIDUpdate) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{2}
}

func (m *X509SVIDUpdate) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_X509SVIDUpdate.Unmarshal(m, b)
}
func (m *X509SVIDUpdate) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_X509SVIDUpdate.Marshal(b, m, deterministic)
}
func (m *X509SVIDUpdate) XXX_Merge(src proto.Message) {
	xxx_messageInfo_X509SVIDUpdate.Merge(m, src)
}
func (m *X509SVIDUpdate) XXX_Size() int {
	return xxx_messageInfo_X509SVIDUpdate.Size(m)
}
func (m *X509SVIDUpdate) XXX_DiscardUnknown() {
	xxx_messageInfo_X509SVIDUpdate.DiscardUnknown(m)
}

var xxx_messageInfo_X509SVIDUpdate proto.InternalMessageInfo

func (m *X509SVIDUpdate) GetSvids() map[string]*X509SVID {
	if m != nil {
		return m.Svids
	}
	return nil
}

func (m *X509SVIDUpdate) GetRegistrationEntries() []*common.RegistrationEntry {
	if m != nil {
		return m.RegistrationEntries
	}
	return nil
}

func (m *X509SVIDUpdate) GetBundles() map[string]*common.Bundle {
	if m != nil {
		return m.Bundles
	}
	return nil
}

// JSR is a JWT SVID signing request.
type JSR struct {
	// SPIFFE ID of the workload
	SpiffeId string `protobuf:"bytes,1,opt,name=spiffe_id,json=spiffeId,proto3" json:"spiffe_id,omitempty"`
	// List of intended audience
	Audience []string `protobuf:"bytes,2,rep,name=audience,proto3" json:"audience,omitempty"`
	// Time-to-live in seconds. If unspecified the JWT SVID will be assigned
	// a default time-to-live by the server.
	Ttl                  int32    `protobuf:"varint,3,opt,name=ttl,proto3" json:"ttl,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *JSR) Reset()         { *m = JSR{} }
func (m *JSR) String() string { return proto.CompactTextString(m) }
func (*JSR) ProtoMessage()    {}
func (*JSR) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{3}
}

func (m *JSR) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_JSR.Unmarshal(m, b)
}
func (m *JSR) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_JSR.Marshal(b, m, deterministic)
}
func (m *JSR) XXX_Merge(src proto.Message) {
	xxx_messageInfo_JSR.Merge(m, src)
}
func (m *JSR) XXX_Size() int {
	return xxx_messageInfo_JSR.Size(m)
}
func (m *JSR) XXX_DiscardUnknown() {
	xxx_messageInfo_JSR.DiscardUnknown(m)
}

var xxx_messageInfo_JSR proto.InternalMessageInfo

func (m *JSR) GetSpiffeId() string {
	if m != nil {
		return m.SpiffeId
	}
	return ""
}

func (m *JSR) GetAudience() []string {
	if m != nil {
		return m.Audience
	}
	return nil
}

func (m *JSR) GetTtl() int32 {
	if m != nil {
		return m.Ttl
	}
	return 0
}

// JWTSVID is a signed JWT-SVID with fields lifted out for convenience.
type JWTSVID struct {
	// JWT-SVID JWT token
	Token string `protobuf:"bytes,1,opt,name=token,proto3" json:"token,omitempty"`
	// SVID expiration timestamp (seconds since Unix epoch)
	ExpiresAt int64 `protobuf:"varint,2,opt,name=expires_at,json=expiresAt,proto3" json:"expires_at,omitempty"`
	// SVID issuance timestamp (seconds since Unix epoch)
	IssuedAt             int64    `protobuf:"varint,3,opt,name=issued_at,json=issuedAt,proto3" json:"issued_at,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *JWTSVID) Reset()         { *m = JWTSVID{} }
func (m *JWTSVID) String() string { return proto.CompactTextString(m) }
func (*JWTSVID) ProtoMessage()    {}
func (*JWTSVID) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{4}
}

func (m *JWTSVID) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_JWTSVID.Unmarshal(m, b)
}
func (m *JWTSVID) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_JWTSVID.Marshal(b, m, deterministic)
}
func (m *JWTSVID) XXX_Merge(src proto.Message) {
	xxx_messageInfo_JWTSVID.Merge(m, src)
}
func (m *JWTSVID) XXX_Size() int {
	return xxx_messageInfo_JWTSVID.Size(m)
}
func (m *JWTSVID) XXX_DiscardUnknown() {
	xxx_messageInfo_JWTSVID.DiscardUnknown(m)
}

var xxx_messageInfo_JWTSVID proto.InternalMessageInfo

func (m *JWTSVID) GetToken() string {
	if m != nil {
		return m.Token
	}
	return ""
}

func (m *JWTSVID) GetExpiresAt() int64 {
	if m != nil {
		return m.ExpiresAt
	}
	return 0
}

func (m *JWTSVID) GetIssuedAt() int64 {
	if m != nil {
		return m.IssuedAt
	}
	return 0
}

// Represents a request to attest the node.
type AttestRequest struct {
	// A type which contains attestation data for specific platform.
	AttestationData *common.AttestationData `protobuf:"bytes,1,opt,name=attestation_data,json=attestationData,proto3" json:"attestation_data,omitempty"`
	// Certificate signing request.
	Csr []byte `protobuf:"bytes,2,opt,name=csr,proto3" json:"csr,omitempty"`
	// Attestation challenge response
	Response             []byte   `protobuf:"bytes,3,opt,name=response,proto3" json:"response,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AttestRequest) Reset()         { *m = AttestRequest{} }
func (m *AttestRequest) String() string { return proto.CompactTextString(m) }
func (*AttestRequest) ProtoMessage()    {}
func (*AttestRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{5}
}

func (m *AttestRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AttestRequest.Unmarshal(m, b)
}
func (m *AttestRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AttestRequest.Marshal(b, m, deterministic)
}
func (m *AttestRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AttestRequest.Merge(m, src)
}
func (m *AttestRequest) XXX_Size() int {
	return xxx_messageInfo_AttestRequest.Size(m)
}
func (m *AttestRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_AttestRequest.DiscardUnknown(m)
}

var xxx_messageInfo_AttestRequest proto.InternalMessageInfo

func (m *AttestRequest) GetAttestationData() *common.AttestationData {
	if m != nil {
		return m.AttestationData
	}
	return nil
}

func (m *AttestRequest) GetCsr() []byte {
	if m != nil {
		return m.Csr
	}
	return nil
}

func (m *AttestRequest) GetResponse() []byte {
	if m != nil {
		return m.Response
	}
	return nil
}

// Represents a response that contains  map of signed SVIDs and an array of
// all current Registration Entries which are relevant to the caller SPIFFE ID
type AttestResponse struct {
	// It includes a map of signed SVIDs and an array of all current
	// Registration Entries which are relevant to the caller SPIFFE ID.
	SvidUpdate *X509SVIDUpdate `protobuf:"bytes,1,opt,name=svid_update,json=svidUpdate,proto3" json:"svid_update,omitempty"`
	// This is a challenge issued by the server to the node. If populated, the
	// node is expected to respond with another AttestRequest with the response.
	// This field is mutually exclusive with the update field.
	Challenge            []byte   `protobuf:"bytes,2,opt,name=challenge,proto3" json:"challenge,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AttestResponse) Reset()         { *m = AttestResponse{} }
func (m *AttestResponse) String() string { return proto.CompactTextString(m) }
func (*AttestResponse) ProtoMessage()    {}
func (*AttestResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{6}
}

func (m *AttestResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AttestResponse.Unmarshal(m, b)
}
func (m *AttestResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AttestResponse.Marshal(b, m, deterministic)
}
func (m *AttestResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AttestResponse.Merge(m, src)
}
func (m *AttestResponse) XXX_Size() int {
	return xxx_messageInfo_AttestResponse.Size(m)
}
func (m *AttestResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_AttestResponse.DiscardUnknown(m)
}

var xxx_messageInfo_AttestResponse proto.InternalMessageInfo

func (m *AttestResponse) GetSvidUpdate() *X509SVIDUpdate {
	if m != nil {
		return m.SvidUpdate
	}
	return nil
}

func (m *AttestResponse) GetChallenge() []byte {
	if m != nil {
		return m.Challenge
	}
	return nil
}

// Represents a request with a list of CSR.
type FetchX509SVIDRequest struct {
	// A list of CSRs (deprecated, use `csrs` map instead)
	DEPRECATEDCsrs [][]byte `protobuf:"bytes,2,rep,name=DEPRECATED_csrs,json=DEPRECATEDCsrs,proto3" json:"DEPRECATED_csrs,omitempty"`
	// A map of CSRs keyed by entry ID
	Csrs                 map[string][]byte `protobuf:"bytes,3,rep,name=csrs,proto3" json:"csrs,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *FetchX509SVIDRequest) Reset()         { *m = FetchX509SVIDRequest{} }
func (m *FetchX509SVIDRequest) String() string { return proto.CompactTextString(m) }
func (*FetchX509SVIDRequest) ProtoMessage()    {}
func (*FetchX509SVIDRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{7}
}

func (m *FetchX509SVIDRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchX509SVIDRequest.Unmarshal(m, b)
}
func (m *FetchX509SVIDRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchX509SVIDRequest.Marshal(b, m, deterministic)
}
func (m *FetchX509SVIDRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchX509SVIDRequest.Merge(m, src)
}
func (m *FetchX509SVIDRequest) XXX_Size() int {
	return xxx_messageInfo_FetchX509SVIDRequest.Size(m)
}
func (m *FetchX509SVIDRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchX509SVIDRequest.DiscardUnknown(m)
}

var xxx_messageInfo_FetchX509SVIDRequest proto.InternalMessageInfo

func (m *FetchX509SVIDRequest) GetDEPRECATEDCsrs() [][]byte {
	if m != nil {
		return m.DEPRECATEDCsrs
	}
	return nil
}

func (m *FetchX509SVIDRequest) GetCsrs() map[string][]byte {
	if m != nil {
		return m.Csrs
	}
	return nil
}

// Represents a response that contains  map of signed SVIDs and an array
// of all current Registration Entries which are relevant to the caller SPIFFE ID.
type FetchX509SVIDResponse struct {
	// It includes a map of signed SVIDs and an array of all current Registration
	// Entries which are relevant to the caller SPIFFE ID.
	SvidUpdate           *X509SVIDUpdate `protobuf:"bytes,1,opt,name=svid_update,json=svidUpdate,proto3" json:"svid_update,omitempty"`
	XXX_NoUnkeyedLiteral struct{}        `json:"-"`
	XXX_unrecognized     []byte          `json:"-"`
	XXX_sizecache        int32           `json:"-"`
}

func (m *FetchX509SVIDResponse) Reset()         { *m = FetchX509SVIDResponse{} }
func (m *FetchX509SVIDResponse) String() string { return proto.CompactTextString(m) }
func (*FetchX509SVIDResponse) ProtoMessage()    {}
func (*FetchX509SVIDResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{8}
}

func (m *FetchX509SVIDResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchX509SVIDResponse.Unmarshal(m, b)
}
func (m *FetchX509SVIDResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchX509SVIDResponse.Marshal(b, m, deterministic)
}
func (m *FetchX509SVIDResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchX509SVIDResponse.Merge(m, src)
}
func (m *FetchX509SVIDResponse) XXX_Size() int {
	return xxx_messageInfo_FetchX509SVIDResponse.Size(m)
}
func (m *FetchX509SVIDResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchX509SVIDResponse.DiscardUnknown(m)
}

var xxx_messageInfo_FetchX509SVIDResponse proto.InternalMessageInfo

func (m *FetchX509SVIDResponse) GetSvidUpdate() *X509SVIDUpdate {
	if m != nil {
		return m.SvidUpdate
	}
	return nil
}

type FetchJWTSVIDRequest struct {
	// The JWT signing request
	Jsr                  *JSR     `protobuf:"bytes,1,opt,name=jsr,proto3" json:"jsr,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *FetchJWTSVIDRequest) Reset()         { *m = FetchJWTSVIDRequest{} }
func (m *FetchJWTSVIDRequest) String() string { return proto.CompactTextString(m) }
func (*FetchJWTSVIDRequest) ProtoMessage()    {}
func (*FetchJWTSVIDRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{9}
}

func (m *FetchJWTSVIDRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchJWTSVIDRequest.Unmarshal(m, b)
}
func (m *FetchJWTSVIDRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchJWTSVIDRequest.Marshal(b, m, deterministic)
}
func (m *FetchJWTSVIDRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchJWTSVIDRequest.Merge(m, src)
}
func (m *FetchJWTSVIDRequest) XXX_Size() int {
	return xxx_messageInfo_FetchJWTSVIDRequest.Size(m)
}
func (m *FetchJWTSVIDRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchJWTSVIDRequest.DiscardUnknown(m)
}

var xxx_messageInfo_FetchJWTSVIDRequest proto.InternalMessageInfo

func (m *FetchJWTSVIDRequest) GetJsr() *JSR {
	if m != nil {
		return m.Jsr
	}
	return nil
}

type FetchJWTSVIDResponse struct {
	// The signed JWT-SVID
	Svid                 *JWTSVID `protobuf:"bytes,1,opt,name=svid,proto3" json:"svid,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *FetchJWTSVIDResponse) Reset()         { *m = FetchJWTSVIDResponse{} }
func (m *FetchJWTSVIDResponse) String() string { return proto.CompactTextString(m) }
func (*FetchJWTSVIDResponse) ProtoMessage()    {}
func (*FetchJWTSVIDResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{10}
}

func (m *FetchJWTSVIDResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchJWTSVIDResponse.Unmarshal(m, b)
}
func (m *FetchJWTSVIDResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchJWTSVIDResponse.Marshal(b, m, deterministic)
}
func (m *FetchJWTSVIDResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchJWTSVIDResponse.Merge(m, src)
}
func (m *FetchJWTSVIDResponse) XXX_Size() int {
	return xxx_messageInfo_FetchJWTSVIDResponse.Size(m)
}
func (m *FetchJWTSVIDResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchJWTSVIDResponse.DiscardUnknown(m)
}

var xxx_messageInfo_FetchJWTSVIDResponse proto.InternalMessageInfo

func (m *FetchJWTSVIDResponse) GetSvid() *JWTSVID {
	if m != nil {
		return m.Svid
	}
	return nil
}

type FetchX509CASVIDRequest struct {
	Csr                  []byte   `protobuf:"bytes,1,opt,name=csr,proto3" json:"csr,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *FetchX509CASVIDRequest) Reset()         { *m = FetchX509CASVIDRequest{} }
func (m *FetchX509CASVIDRequest) String() string { return proto.CompactTextString(m) }
func (*FetchX509CASVIDRequest) ProtoMessage()    {}
func (*FetchX509CASVIDRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{11}
}

func (m *FetchX509CASVIDRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchX509CASVIDRequest.Unmarshal(m, b)
}
func (m *FetchX509CASVIDRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchX509CASVIDRequest.Marshal(b, m, deterministic)
}
func (m *FetchX509CASVIDRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchX509CASVIDRequest.Merge(m, src)
}
func (m *FetchX509CASVIDRequest) XXX_Size() int {
	return xxx_messageInfo_FetchX509CASVIDRequest.Size(m)
}
func (m *FetchX509CASVIDRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchX509CASVIDRequest.DiscardUnknown(m)
}

var xxx_messageInfo_FetchX509CASVIDRequest proto.InternalMessageInfo

func (m *FetchX509CASVIDRequest) GetCsr() []byte {
	if m != nil {
		return m.Csr
	}
	return nil
}

type FetchX509CASVIDResponse struct {
	Svid                 *X509SVID      `protobuf:"bytes,1,opt,name=svid,proto3" json:"svid,omitempty"`
	Bundle               *common.Bundle `protobuf:"bytes,2,opt,name=bundle,proto3" json:"bundle,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *FetchX509CASVIDResponse) Reset()         { *m = FetchX509CASVIDResponse{} }
func (m *FetchX509CASVIDResponse) String() string { return proto.CompactTextString(m) }
func (*FetchX509CASVIDResponse) ProtoMessage()    {}
func (*FetchX509CASVIDResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{12}
}

func (m *FetchX509CASVIDResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchX509CASVIDResponse.Unmarshal(m, b)
}
func (m *FetchX509CASVIDResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchX509CASVIDResponse.Marshal(b, m, deterministic)
}
func (m *FetchX509CASVIDResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchX509CASVIDResponse.Merge(m, src)
}
func (m *FetchX509CASVIDResponse) XXX_Size() int {
	return xxx_messageInfo_FetchX509CASVIDResponse.Size(m)
}
func (m *FetchX509CASVIDResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchX509CASVIDResponse.DiscardUnknown(m)
}

var xxx_messageInfo_FetchX509CASVIDResponse proto.InternalMessageInfo

func (m *FetchX509CASVIDResponse) GetSvid() *X509SVID {
	if m != nil {
		return m.Svid
	}
	return nil
}

func (m *FetchX509CASVIDResponse) GetBundle() *common.Bundle {
	if m != nil {
		return m.Bundle
	}
	return nil
}

type PushJWTKeyUpstreamRequest struct {
	JwtKey               *common.PublicKey `protobuf:"bytes,1,opt,name=jwt_key,json=jwtKey,proto3" json:"jwt_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *PushJWTKeyUpstreamRequest) Reset()         { *m = PushJWTKeyUpstreamRequest{} }
func (m *PushJWTKeyUpstreamRequest) String() string { return proto.CompactTextString(m) }
func (*PushJWTKeyUpstreamRequest) ProtoMessage()    {}
func (*PushJWTKeyUpstreamRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{13}
}

func (m *PushJWTKeyUpstreamRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_PushJWTKeyUpstreamRequest.Unmarshal(m, b)
}
func (m *PushJWTKeyUpstreamRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_PushJWTKeyUpstreamRequest.Marshal(b, m, deterministic)
}
func (m *PushJWTKeyUpstreamRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_PushJWTKeyUpstreamRequest.Merge(m, src)
}
func (m *PushJWTKeyUpstreamRequest) XXX_Size() int {
	return xxx_messageInfo_PushJWTKeyUpstreamRequest.Size(m)
}
func (m *PushJWTKeyUpstreamRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_PushJWTKeyUpstreamRequest.DiscardUnknown(m)
}

var xxx_messageInfo_PushJWTKeyUpstreamRequest proto.InternalMessageInfo

func (m *PushJWTKeyUpstreamRequest) GetJwtKey() *common.PublicKey {
	if m != nil {
		return m.JwtKey
	}
	return nil
}

type PushJWTKeyUpstreamResponse struct {
	// up-to-date bundle of JWT signing keys
	JwtSigningKeys       []*common.PublicKey `protobuf:"bytes,1,rep,name=jwt_signing_keys,json=jwtSigningKeys,proto3" json:"jwt_signing_keys,omitempty"`
	XXX_NoUnkeyedLiteral struct{}            `json:"-"`
	XXX_unrecognized     []byte              `json:"-"`
	XXX_sizecache        int32               `json:"-"`
}

func (m *PushJWTKeyUpstreamResponse) Reset()         { *m = PushJWTKeyUpstreamResponse{} }
func (m *PushJWTKeyUpstreamResponse) String() string { return proto.CompactTextString(m) }
func (*PushJWTKeyUpstreamResponse) ProtoMessage()    {}
func (*PushJWTKeyUpstreamResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{14}
}

func (m *PushJWTKeyUpstreamResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_PushJWTKeyUpstreamResponse.Unmarshal(m, b)
}
func (m *PushJWTKeyUpstreamResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_PushJWTKeyUpstreamResponse.Marshal(b, m, deterministic)
}
func (m *PushJWTKeyUpstreamResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_PushJWTKeyUpstreamResponse.Merge(m, src)
}
func (m *PushJWTKeyUpstreamResponse) XXX_Size() int {
	return xxx_messageInfo_PushJWTKeyUpstreamResponse.Size(m)
}
func (m *PushJWTKeyUpstreamResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_PushJWTKeyUpstreamResponse.DiscardUnknown(m)
}

var xxx_messageInfo_PushJWTKeyUpstreamResponse proto.InternalMessageInfo

func (m *PushJWTKeyUpstreamResponse) GetJwtSigningKeys() []*common.PublicKey {
	if m != nil {
		return m.JwtSigningKeys
	}
	return nil
}

type FetchBundleRequest struct {
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *FetchBundleRequest) Reset()         { *m = FetchBundleRequest{} }
func (m *FetchBundleRequest) String() string { return proto.CompactTextString(m) }
func (*FetchBundleRequest) ProtoMessage()    {}
func (*FetchBundleRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{15}
}

func (m *FetchBundleRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchBundleRequest.Unmarshal(m, b)
}
func (m *FetchBundleRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchBundleRequest.Marshal(b, m, deterministic)
}
func (m *FetchBundleRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchBundleRequest.Merge(m, src)
}
func (m *FetchBundleRequest) XXX_Size() int {
	return xxx_messageInfo_FetchBundleRequest.Size(m)
}
func (m *FetchBundleRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchBundleRequest.DiscardUnknown(m)
}

var xxx_messageInfo_FetchBundleRequest proto.InternalMessageInfo

type FetchBundleResponse struct {
	Bundle               *common.Bundle `protobuf:"bytes,1,opt,name=bundle,proto3" json:"bundle,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *FetchBundleResponse) Reset()         { *m = FetchBundleResponse{} }
func (m *FetchBundleResponse) String() string { return proto.CompactTextString(m) }
func (*FetchBundleResponse) ProtoMessage()    {}
func (*FetchBundleResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c843d59d2d938e7, []int{16}
}

func (m *FetchBundleResponse) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FetchBundleResponse.Unmarshal(m, b)
}
func (m *FetchBundleResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FetchBundleResponse.Marshal(b, m, deterministic)
}
func (m *FetchBundleResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FetchBundleResponse.Merge(m, src)
}
func (m *FetchBundleResponse) XXX_Size() int {
	return xxx_messageInfo_FetchBundleResponse.Size(m)
}
func (m *FetchBundleResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_FetchBundleResponse.DiscardUnknown(m)
}

var xxx_messageInfo_FetchBundleResponse proto.InternalMessageInfo

func (m *FetchBundleResponse) GetBundle() *common.Bundle {
	if m != nil {
		return m.Bundle
	}
	return nil
}

func init() {
	proto.RegisterType((*Bundle)(nil), "spire.api.node.Bundle")
	proto.RegisterType((*X509SVID)(nil), "spire.api.node.X509SVID")
	proto.RegisterType((*X509SVIDUpdate)(nil), "spire.api.node.X509SVIDUpdate")
	proto.RegisterMapType((map[string]*common.Bundle)(nil), "spire.api.node.X509SVIDUpdate.BundlesEntry")
	proto.RegisterMapType((map[string]*X509SVID)(nil), "spire.api.node.X509SVIDUpdate.SvidsEntry")
	proto.RegisterType((*JSR)(nil), "spire.api.node.JSR")
	proto.RegisterType((*JWTSVID)(nil), "spire.api.node.JWTSVID")
	proto.RegisterType((*AttestRequest)(nil), "spire.api.node.AttestRequest")
	proto.RegisterType((*AttestResponse)(nil), "spire.api.node.AttestResponse")
	proto.RegisterType((*FetchX509SVIDRequest)(nil), "spire.api.node.FetchX509SVIDRequest")
	proto.RegisterMapType((map[string][]byte)(nil), "spire.api.node.FetchX509SVIDRequest.CsrsEntry")
	proto.RegisterType((*FetchX509SVIDResponse)(nil), "spire.api.node.FetchX509SVIDResponse")
	proto.RegisterType((*FetchJWTSVIDRequest)(nil), "spire.api.node.FetchJWTSVIDRequest")
	proto.RegisterType((*FetchJWTSVIDResponse)(nil), "spire.api.node.FetchJWTSVIDResponse")
	proto.RegisterType((*FetchX509CASVIDRequest)(nil), "spire.api.node.FetchX509CASVIDRequest")
	proto.RegisterType((*FetchX509CASVIDResponse)(nil), "spire.api.node.FetchX509CASVIDResponse")
	proto.RegisterType((*PushJWTKeyUpstreamRequest)(nil), "spire.api.node.PushJWTKeyUpstreamRequest")
	proto.RegisterType((*PushJWTKeyUpstreamResponse)(nil), "spire.api.node.PushJWTKeyUpstreamResponse")
	proto.RegisterType((*FetchBundleRequest)(nil), "spire.api.node.FetchBundleRequest")
	proto.RegisterType((*FetchBundleResponse)(nil), "spire.api.node.FetchBundleResponse")
}

func init() { proto.RegisterFile("node.proto", fileDescriptor_0c843d59d2d938e7) }

var fileDescriptor_0c843d59d2d938e7 = []byte{
	// 933 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x56, 0x5d, 0x6f, 0x1a, 0x47,
	0x14, 0xd5, 0x7a, 0x0d, 0x86, 0x0b, 0xc1, 0xd6, 0x98, 0x36, 0x78, 0x5b, 0xa7, 0xd6, 0x26, 0x69,
	0x5c, 0xc7, 0x5a, 0x5b, 0x8e, 0xaa, 0x7e, 0xa8, 0x52, 0x84, 0x31, 0x55, 0x62, 0xd4, 0x0a, 0x0d,
	0x49, 0x9a, 0xb6, 0x0f, 0x74, 0xd8, 0x9d, 0xe0, 0xb1, 0xf1, 0x2e, 0xdd, 0x99, 0x8d, 0xcb, 0x2f,
	0xe8, 0x7b, 0xff, 0x4d, 0xa5, 0xfe, 0xb8, 0x6a, 0x3e, 0x16, 0x76, 0x31, 0x98, 0x3c, 0xe4, 0x89,
	0x9d, 0x3b, 0xe7, 0x9e, 0x7b, 0xef, 0xd9, 0x33, 0xc3, 0x02, 0x84, 0x51, 0x40, 0xbd, 0x71, 0x1c,
	0x89, 0x08, 0xd5, 0xf8, 0x98, 0xc5, 0xd4, 0x23, 0x63, 0xe6, 0xc9, 0xa8, 0xb3, 0xa3, 0xd6, 0x47,
	0x7e, 0x74, 0x7d, 0x1d, 0x85, 0xe6, 0x47, 0x43, 0xdd, 0x67, 0x50, 0x3c, 0x4d, 0xc2, 0x60, 0x44,
	0x51, 0x0d, 0xd6, 0x58, 0xd0, 0xb0, 0xf6, 0xac, 0xfd, 0x32, 0x5e, 0x63, 0x01, 0xda, 0x81, 0x92,
	0x4f, 0xfa, 0x3e, 0x8d, 0x05, 0x6f, 0xac, 0xed, 0x59, 0xfb, 0x55, 0xbc, 0xe1, 0x93, 0x96, 0x5c,
	0xba, 0x2f, 0xa0, 0xf4, 0xf6, 0xeb, 0xe3, 0xef, 0x7a, 0x6f, 0x5e, 0x9e, 0xa1, 0x5d, 0x00, 0x89,
	0xe9, 0xfb, 0x17, 0x84, 0x85, 0x0d, 0x5b, 0x01, 0xcb, 0x32, 0xd2, 0x92, 0x01, 0xb9, 0x4d, 0xff,
	0x92, 0xd5, 0x79, 0x9f, 0x08, 0xc5, 0x63, 0xe3, 0xb2, 0x89, 0x34, 0x85, 0xfb, 0x8f, 0x0d, 0xb5,
	0x94, 0xea, 0xf5, 0x38, 0x20, 0x82, 0xa2, 0xe7, 0x50, 0xe0, 0xef, 0x59, 0xc0, 0x1b, 0xd6, 0x9e,
	0xbd, 0x5f, 0x39, 0xf9, 0xca, 0xcb, 0x0f, 0xe3, 0xe5, 0xe1, 0x5e, 0x4f, 0x62, 0xdb, 0xa1, 0x88,
	0x27, 0x58, 0xe7, 0x21, 0x0c, 0xf5, 0x98, 0x0e, 0x19, 0x17, 0x31, 0x11, 0x2c, 0x0a, 0xfb, 0x34,
	0x14, 0x31, 0xa3, 0xbc, 0x61, 0x2b, 0xbe, 0x2f, 0x0c, 0x9f, 0x51, 0x01, 0x67, 0x90, 0x9a, 0x65,
	0x3b, 0x9e, 0x0b, 0x31, 0xca, 0x51, 0x1b, 0x36, 0x06, 0x4a, 0x26, 0xde, 0x28, 0x28, 0x9a, 0xa7,
	0x2b, 0xda, 0xd2, 0xa2, 0x9a, 0xc6, 0xd2, 0x5c, 0x07, 0x03, 0xcc, 0xfa, 0x45, 0x5b, 0x60, 0x5f,
	0xd1, 0x89, 0x91, 0x5c, 0x3e, 0x22, 0x0f, 0x0a, 0xef, 0xc9, 0x28, 0xa1, 0x4a, 0xa8, 0xca, 0x49,
	0x63, 0x59, 0x11, 0xac, 0x61, 0xdf, 0xaf, 0x7d, 0x6b, 0x39, 0x5d, 0xa8, 0x66, 0x8b, 0x2d, 0x60,
	0x3d, 0xc8, 0xb3, 0xd6, 0xf3, 0x0a, 0xe8, 0xe4, 0x0c, 0xa3, 0xdb, 0x05, 0xfb, 0xbc, 0x87, 0xd1,
	0x67, 0x50, 0xe6, 0x63, 0xf6, 0xee, 0x1d, 0xed, 0x4f, 0x7d, 0x51, 0xd2, 0x81, 0x97, 0x01, 0x72,
	0xa0, 0x44, 0x92, 0x80, 0xd1, 0xd0, 0x97, 0xb4, 0xb6, 0xdc, 0x4b, 0xd7, 0xb2, 0x03, 0x21, 0x46,
	0xca, 0x0b, 0x05, 0x2c, 0x1f, 0xdd, 0xdf, 0x61, 0xe3, 0xfc, 0x97, 0x57, 0xca, 0x2f, 0x75, 0x28,
	0x88, 0xe8, 0x8a, 0x86, 0x86, 0x51, 0x2f, 0x56, 0xd8, 0x44, 0xb6, 0xc2, 0x38, 0x4f, 0x68, 0x20,
	0x77, 0x6d, 0xb5, 0x5b, 0xd2, 0x81, 0xa6, 0x70, 0xff, 0xb6, 0xe0, 0x5e, 0x53, 0x08, 0xca, 0x05,
	0xa6, 0x7f, 0x26, 0x94, 0x0b, 0xf4, 0x02, 0xb6, 0x88, 0x0a, 0x68, 0x03, 0x04, 0x44, 0x10, 0x55,
	0xae, 0x72, 0xb2, 0x9b, 0x9f, 0xbd, 0x39, 0x43, 0x9d, 0x11, 0x41, 0xf0, 0x26, 0xc9, 0x07, 0xe4,
	0x28, 0x3e, 0x8f, 0x8d, 0xff, 0xe5, 0xa3, 0x1c, 0x3c, 0xa6, 0x7c, 0x1c, 0x85, 0x9c, 0x1a, 0xb7,
	0x4f, 0xd7, 0x6e, 0x04, 0xb5, 0xb4, 0x11, 0x1d, 0x41, 0xcf, 0xa1, 0x22, 0x4d, 0xd9, 0x4f, 0x94,
	0x2b, 0x4c, 0x13, 0x0f, 0xee, 0xf6, 0x0e, 0x06, 0x99, 0x62, 0x4e, 0xc3, 0xe7, 0x50, 0xf6, 0x2f,
	0xc8, 0x68, 0x44, 0xc3, 0x21, 0x35, 0x6d, 0xcc, 0x02, 0xee, 0x7f, 0x16, 0xd4, 0x7f, 0xa4, 0xc2,
	0xbf, 0x98, 0x1a, 0xc3, 0x28, 0xf0, 0x04, 0x36, 0xcf, 0xda, 0x5d, 0xdc, 0x6e, 0x35, 0x5f, 0xb5,
	0xcf, 0xfa, 0x3e, 0x8f, 0xb9, 0x7a, 0x4b, 0x55, 0x5c, 0x9b, 0x85, 0x5b, 0x3c, 0xe6, 0xe8, 0x14,
	0xd6, 0xd5, 0xae, 0x3e, 0x1c, 0xde, 0x7c, 0x67, 0x8b, 0xc8, 0x3d, 0x99, 0xa8, 0x8d, 0xad, 0x72,
	0x9d, 0x6f, 0xa0, 0x3c, 0x0d, 0x2d, 0xb0, 0x5f, 0x3d, 0x6b, 0xbf, 0x6a, 0xd6, 0x68, 0x6f, 0xe1,
	0x93, 0xb9, 0x02, 0x1f, 0x49, 0x36, 0xf7, 0x07, 0xd8, 0x56, 0xcc, 0xc6, 0x75, 0xa9, 0x2c, 0x8f,
	0xc1, 0xbe, 0xe4, 0xb1, 0xe1, 0xdb, 0x9e, 0xe7, 0x3b, 0xef, 0x61, 0x2c, 0xf7, 0xdd, 0x96, 0x51,
	0x75, 0x9a, 0x6d, 0xda, 0x7a, 0x0a, 0xeb, 0xb2, 0x86, 0xc9, 0xbf, 0x7f, 0x2b, 0xdf, 0xc0, 0x15,
	0xc8, 0x3d, 0x80, 0x4f, 0xa7, 0xc3, 0xb5, 0x9a, 0xd9, 0x2e, 0x8c, 0xa9, 0xac, 0xa9, 0xa9, 0xdc,
	0x04, 0xee, 0xdf, 0xc2, 0x9a, 0x9a, 0x87, 0xb9, 0x9a, 0xcb, 0x6f, 0x04, 0x85, 0x42, 0x87, 0x50,
	0xd4, 0x77, 0xcd, 0x9d, 0x67, 0xdd, 0x60, 0xdc, 0x9f, 0x60, 0xa7, 0x9b, 0x70, 0x39, 0x66, 0x87,
	0x4e, 0x5e, 0x8f, 0xb9, 0x88, 0x29, 0xb9, 0x4e, 0xbb, 0x3c, 0x86, 0x8d, 0xcb, 0x1b, 0xd1, 0x4f,
	0x5f, 0xe6, 0x6c, 0x5e, 0xc3, 0xd5, 0x4d, 0x06, 0x23, 0xe6, 0x77, 0xe8, 0x04, 0x17, 0x2f, 0x6f,
	0x44, 0x87, 0x4e, 0xdc, 0x3e, 0x38, 0x8b, 0xe8, 0xcc, 0x20, 0x4d, 0xd8, 0x92, 0x7c, 0x9c, 0x0d,
	0x43, 0x16, 0x0e, 0x25, 0x6f, 0x7a, 0xc5, 0x2f, 0x25, 0xae, 0x5d, 0xde, 0x88, 0x9e, 0xc6, 0x77,
	0xe8, 0x84, 0xbb, 0x75, 0x40, 0x4a, 0x26, 0x33, 0x86, 0x6e, 0xd4, 0x6d, 0x99, 0x77, 0x9d, 0x46,
	0xa7, 0xc2, 0xa5, 0x52, 0x58, 0xab, 0xa5, 0x38, 0xf9, 0x77, 0x1d, 0xd6, 0x7f, 0x8e, 0x02, 0x8a,
	0x3a, 0x50, 0xd4, 0x67, 0x18, 0xed, 0xce, 0x6b, 0x9d, 0xbb, 0x64, 0x9c, 0x07, 0xcb, 0xb6, 0x75,
	0xfd, 0x7d, 0xeb, 0xd8, 0x42, 0x7f, 0xc0, 0xbd, 0x9c, 0xc1, 0xd1, 0xa3, 0x0f, 0x39, 0x60, 0xce,
	0xe3, 0x15, 0xa8, 0x4c, 0x85, 0x5f, 0xa1, 0x9a, 0xb5, 0x2a, 0x7a, 0xb8, 0x30, 0x35, 0x7f, 0x0c,
	0x9c, 0x47, 0x77, 0x83, 0x8c, 0x80, 0x03, 0xd8, 0x9c, 0x33, 0x25, 0xfa, 0x72, 0x69, 0x63, 0x39,
	0x87, 0x3b, 0x4f, 0x56, 0xe2, 0x4c, 0x8d, 0x2b, 0x40, 0xb7, 0x2d, 0x83, 0x6e, 0xfd, 0xe7, 0x2f,
	0x75, 0xa9, 0x73, 0xf0, 0x21, 0x50, 0x53, 0xec, 0x0d, 0x54, 0x32, 0x46, 0x41, 0xee, 0xc2, 0x26,
	0x73, 0xde, 0x72, 0x1e, 0xde, 0x89, 0xd1, 0xbc, 0xa7, 0xde, 0x6f, 0x87, 0x43, 0x26, 0x2e, 0x92,
	0x81, 0xf4, 0xd6, 0x91, 0xfe, 0x8b, 0x3c, 0xd2, 0x9f, 0x5c, 0xea, 0x23, 0xcb, 0x3c, 0x93, 0x31,
	0x3b, 0x92, 0x1c, 0x83, 0xa2, 0x8a, 0x3e, 0xfb, 0x3f, 0x00, 0x00, 0xff, 0xff, 0x22, 0xfc, 0x6f,
	0xa7, 0xb3, 0x09, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// NodeClient is the client API for Node service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type NodeClient interface {
	// Attest the node, get base node SVID.
	Attest(ctx context.Context, opts ...grpc.CallOption) (Node_AttestClient, error)
	// Get Workload, Node Agent certs and CA trust bundles. Also used for rotation
	// Base Node SVID or the Registered Node SVID used for this call)
	// List can be empty to allow Node Agent cache refresh).
	FetchX509SVID(ctx context.Context, opts ...grpc.CallOption) (Node_FetchX509SVIDClient, error)
	// Fetches a signed JWT-SVID for a workload intended for a specific audience.
	FetchJWTSVID(ctx context.Context, in *FetchJWTSVIDRequest, opts ...grpc.CallOption) (*FetchJWTSVIDResponse, error)
	// Fetches an X509 CA SVID for a downstream SPIRE server.
	FetchX509CASVID(ctx context.Context, in *FetchX509CASVIDRequest, opts ...grpc.CallOption) (*FetchX509CASVIDResponse, error)
	// PushJWTKeyUpstream pushes new public JWKs to upstream SPIRE Server, unless this
	// is the root server, in which case it stores the JWK in its bundle. Returns an
	// up-to-date list of the JWT signing keys stored in the bundle.
	PushJWTKeyUpstream(ctx context.Context, in *PushJWTKeyUpstreamRequest, opts ...grpc.CallOption) (*PushJWTKeyUpstreamResponse, error)
	// FetchBundle fetches the bundle of the local trust domain
	FetchBundle(ctx context.Context, in *FetchBundleRequest, opts ...grpc.CallOption) (*FetchBundleResponse, error)
}

type nodeClient struct {
	cc *grpc.ClientConn
}

func NewNodeClient(cc *grpc.ClientConn) NodeClient {
	return &nodeClient{cc}
}

func (c *nodeClient) Attest(ctx context.Context, opts ...grpc.CallOption) (Node_AttestClient, error) {
	stream, err := c.cc.NewStream(ctx, &_Node_serviceDesc.Streams[0], "/spire.api.node.Node/Attest", opts...)
	if err != nil {
		return nil, err
	}
	x := &nodeAttestClient{stream}
	return x, nil
}

type Node_AttestClient interface {
	Send(*AttestRequest) error
	Recv() (*AttestResponse, error)
	grpc.ClientStream
}

type nodeAttestClient struct {
	grpc.ClientStream
}

func (x *nodeAttestClient) Send(m *AttestRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *nodeAttestClient) Recv() (*AttestResponse, error) {
	m := new(AttestResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *nodeClient) FetchX509SVID(ctx context.Context, opts ...grpc.CallOption) (Node_FetchX509SVIDClient, error) {
	stream, err := c.cc.NewStream(ctx, &_Node_serviceDesc.Streams[1], "/spire.api.node.Node/FetchX509SVID", opts...)
	if err != nil {
		return nil, err
	}
	x := &nodeFetchX509SVIDClient{stream}
	return x, nil
}

type Node_FetchX509SVIDClient interface {
	Send(*FetchX509SVIDRequest) error
	Recv() (*FetchX509SVIDResponse, error)
	grpc.ClientStream
}

type nodeFetchX509SVIDClient struct {
	grpc.ClientStream
}

func (x *nodeFetchX509SVIDClient) Send(m *FetchX509SVIDRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *nodeFetchX509SVIDClient) Recv() (*FetchX509SVIDResponse, error) {
	m := new(FetchX509SVIDResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *nodeClient) FetchJWTSVID(ctx context.Context, in *FetchJWTSVIDRequest, opts ...grpc.CallOption) (*FetchJWTSVIDResponse, error) {
	out := new(FetchJWTSVIDResponse)
	err := c.cc.Invoke(ctx, "/spire.api.node.Node/FetchJWTSVID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) FetchX509CASVID(ctx context.Context, in *FetchX509CASVIDRequest, opts ...grpc.CallOption) (*FetchX509CASVIDResponse, error) {
	out := new(FetchX509CASVIDResponse)
	err := c.cc.Invoke(ctx, "/spire.api.node.Node/FetchX509CASVID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) PushJWTKeyUpstream(ctx context.Context, in *PushJWTKeyUpstreamRequest, opts ...grpc.CallOption) (*PushJWTKeyUpstreamResponse, error) {
	out := new(PushJWTKeyUpstreamResponse)
	err := c.cc.Invoke(ctx, "/spire.api.node.Node/PushJWTKeyUpstream", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) FetchBundle(ctx context.Context, in *FetchBundleRequest, opts ...grpc.CallOption) (*FetchBundleResponse, error) {
	out := new(FetchBundleResponse)
	err := c.cc.Invoke(ctx, "/spire.api.node.Node/FetchBundle", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// NodeServer is the server API for Node service.
type NodeServer interface {
	// Attest the node, get base node SVID.
	Attest(Node_AttestServer) error
	// Get Workload, Node Agent certs and CA trust bundles. Also used for rotation
	// Base Node SVID or the Registered Node SVID used for this call)
	// List can be empty to allow Node Agent cache refresh).
	FetchX509SVID(Node_FetchX509SVIDServer) error
	// Fetches a signed JWT-SVID for a workload intended for a specific audience.
	FetchJWTSVID(context.Context, *FetchJWTSVIDRequest) (*FetchJWTSVIDResponse, error)
	// Fetches an X509 CA SVID for a downstream SPIRE server.
	FetchX509CASVID(context.Context, *FetchX509CASVIDRequest) (*FetchX509CASVIDResponse, error)
	// PushJWTKeyUpstream pushes new public JWKs to upstream SPIRE Server, unless this
	// is the root server, in which case it stores the JWK in its bundle. Returns an
	// up-to-date list of the JWT signing keys stored in the bundle.
	PushJWTKeyUpstream(context.Context, *PushJWTKeyUpstreamRequest) (*PushJWTKeyUpstreamResponse, error)
	// FetchBundle fetches the bundle of the local trust domain
	FetchBundle(context.Context, *FetchBundleRequest) (*FetchBundleResponse, error)
}

// UnimplementedNodeServer can be embedded to have forward compatible implementations.
type UnimplementedNodeServer struct {
}

func (*UnimplementedNodeServer) Attest(srv Node_AttestServer) error {
	return status.Errorf(codes.Unimplemented, "method Attest not implemented")
}
func (*UnimplementedNodeServer) FetchX509SVID(srv Node_FetchX509SVIDServer) error {
	return status.Errorf(codes.Unimplemented, "method FetchX509SVID not implemented")
}
func (*UnimplementedNodeServer) FetchJWTSVID(ctx context.Context, req *FetchJWTSVIDRequest) (*FetchJWTSVIDResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FetchJWTSVID not implemented")
}
func (*UnimplementedNodeServer) FetchX509CASVID(ctx context.Context, req *FetchX509CASVIDRequest) (*FetchX509CASVIDResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FetchX509CASVID not implemented")
}
func (*UnimplementedNodeServer) PushJWTKeyUpstream(ctx context.Context, req *PushJWTKeyUpstreamRequest) (*PushJWTKeyUpstreamResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method PushJWTKeyUpstream not implemented")
}
func (*UnimplementedNodeServer) FetchBundle(ctx context.Context, req *FetchBundleRequest) (*FetchBundleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FetchBundle not implemented")
}

func RegisterNodeServer(s *grpc.Server, srv NodeServer) {
	s.RegisterService(&_Node_serviceDesc, srv)
}

func _Node_Attest_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(NodeServer).Attest(&nodeAttestServer{stream})
}

type Node_AttestServer interface {
	Send(*AttestResponse) error
	Recv() (*AttestRequest, error)
	grpc.ServerStream
}

type nodeAttestServer struct {
	grpc.ServerStream
}

func (x *nodeAttestServer) Send(m *AttestResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *nodeAttestServer) Recv() (*AttestRequest, error) {
	m := new(AttestRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Node_FetchX509SVID_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(NodeServer).FetchX509SVID(&nodeFetchX509SVIDServer{stream})
}

type Node_FetchX509SVIDServer interface {
	Send(*FetchX509SVIDResponse) error
	Recv() (*FetchX509SVIDRequest, error)
	grpc.ServerStream
}

type nodeFetchX509SVIDServer struct {
	grpc.ServerStream
}

func (x *nodeFetchX509SVIDServer) Send(m *FetchX509SVIDResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *nodeFetchX509SVIDServer) Recv() (*FetchX509SVIDRequest, error) {
	m := new(FetchX509SVIDRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Node_FetchJWTSVID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FetchJWTSVIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).FetchJWTSVID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.api.node.Node/FetchJWTSVID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).FetchJWTSVID(ctx, req.(*FetchJWTSVIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_FetchX509CASVID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FetchX509CASVIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).FetchX509CASVID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.api.node.Node/FetchX509CASVID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).FetchX509CASVID(ctx, req.(*FetchX509CASVIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_PushJWTKeyUpstream_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PushJWTKeyUpstreamRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).PushJWTKeyUpstream(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.api.node.Node/PushJWTKeyUpstream",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).PushJWTKeyUpstream(ctx, req.(*PushJWTKeyUpstreamRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_FetchBundle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FetchBundleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).FetchBundle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.api.node.Node/FetchBundle",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).FetchBundle(ctx, req.(*FetchBundleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Node_serviceDesc = grpc.ServiceDesc{
	ServiceName: "spire.api.node.Node",
	HandlerType: (*NodeServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "FetchJWTSVID",
			Handler:    _Node_FetchJWTSVID_Handler,
		},
		{
			MethodName: "FetchX509CASVID",
			Handler:    _Node_FetchX509CASVID_Handler,
		},
		{
			MethodName: "PushJWTKeyUpstream",
			Handler:    _Node_PushJWTKeyUpstream_Handler,
		},
		{
			MethodName: "FetchBundle",
			Handler:    _Node_FetchBundle_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Attest",
			Handler:       _Node_Attest_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "FetchX509SVID",
			Handler:       _Node_FetchX509SVID_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "node.proto",
}
